#!/usr/bin/env python
import re
import h5py
import os
import sys
import glob
import argparse
from os.path import isfile

def readh5(filename, aye, bye, ins):
  global args

  fstrl = os.getcwd() + "/" + filename
  file = h5py.File(fstrl, 'r')

  n0=file["/1"].attrs["norm"]
  sh=file["/1"].attrs["s13"]
  wz=file["/1"].attrs["s33z"]
  it=file["/1"].attrs["s32x"]
  ovx=file["/1"].attrs["ovx"]
  ovy=file["/1"].attrs["ovy"]
  ovz=file["/1"].attrs["ovz"]
  ti=file["/1"].attrs["time"]
  tt=file["/1"].attrs["T"]
  file.close()

  fstrl = os.getcwd() + "/" + re.sub(r'(.*)C_0(.*)','\\1C_1\\2',filename)
  file = h5py.File(fstrl, 'r')
  n1=file["/1"].attrs["norm"]
  file.close()
  
  fstrl = os.getcwd() + "/" + re.sub(r'(.*)C_0(.*)','\\1C_2\\2',filename)
  file = h5py.File(fstrl, 'r')
  n2=file["/1"].attrs["norm"]
  file.close()

  return n0, n1, n2, sh, wz, ti/tt, it, ovx, ovy, ovz, float(aye), float(bye), float(ins)

parser = argparse.ArgumentParser(description='determine what to render and how to render it')
parser.add_argument('-verbose', action="store_true", help='Output diagnostic info')
parser.add_argument('-inp', nargs='?', type=str, help='Set input file string manually')
args=parser.parse_args()

stripStr="evo*C_0*h5"
if args.inp:
  stripStr=args.inp

ofile=open("nout.adat", "w")
ofile2=open("nout2.adat", "w")
ays=[]
bes=[]
ins=[]
for gleb in sorted(glob.glob(stripStr)):
  ays.append(re.sub(r'.*a_(.*)_b.*','\\1',gleb))
  bes.append(re.sub(r'.*b_(.*)_C.*','\\1',gleb))
  ins.append(re.sub(r'.*C_0_(.*).h5','\\1',gleb))


print sorted(list(set(ays)))
print sorted(list(set(bes)))
print sorted(list(set(ins)))

fstr="evo_a_%s" % ays[1] + "_b_%s" % bes[1] + "_C_0_%s" % ins[1] + ".h5"
print ("%13.6e "*13 + "\n") % readh5(fstr, ays[1], bes[1], ins[1])

for aye in sorted(list(set(ays))):
  for bye in sorted(list(set(bes))):
    for ine in sorted(list(set(ins))):
      fstr="evo_a_%s" % aye + "_b_%s" % bye + "_C_0_%s" % ine + ".h5"
      if isfile(os.getcwd() + "/" + fstr):
        ofile.write(("%13.6e "*13 + "\n") % readh5(fstr, aye, bye, ine))
    fstr="evo_a_%s" % aye + "_b_%s" % bye + "_C_0_0100.h5"
    if isfile(os.getcwd() + "/" + fstr):
      ofile2.write(("%13.6e "*13 + "\n") % readh5(fstr, aye, bye, ine))
  ofile.write("\n")
ofile.close()
ofile2.close()
    
for aye in sorted(list(set(ays))):
  ofile3=open("nout_"+aye+".adat", "w")
  for bye in sorted(list(set(bes))):
    for ine in sorted(list(set(ins))):
      fstr="evo_a_%s" % aye + "_b_%s" % bye + "_C_0_%s" % ine + ".h5"
      if isfile(os.getcwd() + "/" + fstr):
        ofile3.write(("%13.6e "*13 + "\n") % readh5(fstr, aye, bye, ine))
  ofile3.close()
